"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "ScreenGridLayer", {
  enumerable: true,
  get: function get() {
    return _screenGridLayer["default"];
  }
});
Object.defineProperty(exports, "CPUGridLayer", {
  enumerable: true,
  get: function get() {
    return _cpuGridLayer["default"];
  }
});
Object.defineProperty(exports, "HexagonLayer", {
  enumerable: true,
  get: function get() {
    return _hexagonLayer["default"];
  }
});
Object.defineProperty(exports, "ContourLayer", {
  enumerable: true,
  get: function get() {
    return _contourLayer["default"];
  }
});
Object.defineProperty(exports, "GridLayer", {
  enumerable: true,
  get: function get() {
    return _gridLayer["default"];
  }
});
Object.defineProperty(exports, "GPUGridLayer", {
  enumerable: true,
  get: function get() {
    return _gpuGridLayer["default"];
  }
});
Object.defineProperty(exports, "AGGREGATION_OPERATION", {
  enumerable: true,
  get: function get() {
    return _aggregationOperationUtils.AGGREGATION_OPERATION;
  }
});
Object.defineProperty(exports, "HeatmapLayer", {
  enumerable: true,
  get: function get() {
    return _heatmapLayer["default"];
  }
});
Object.defineProperty(exports, "_GPUGridAggregator", {
  enumerable: true,
  get: function get() {
    return _gpuGridAggregator["default"];
  }
});
exports.experimental = void 0;

var _screenGridLayer = _interopRequireDefault(require("./screen-grid-layer/screen-grid-layer"));

var _cpuGridLayer = _interopRequireDefault(require("./cpu-grid-layer/cpu-grid-layer"));

var _hexagonLayer = _interopRequireDefault(require("./hexagon-layer/hexagon-layer"));

var _contourLayer = _interopRequireDefault(require("./contour-layer/contour-layer"));

var _gridLayer = _interopRequireDefault(require("./grid-layer/grid-layer"));

var _gpuGridLayer = _interopRequireDefault(require("./gpu-grid-layer/gpu-grid-layer"));

var _aggregationOperationUtils = require("./utils/aggregation-operation-utils");

var _heatmapLayer = _interopRequireDefault(require("./heatmap-layer/heatmap-layer"));

var _gpuGridAggregator = _interopRequireDefault(require("./utils/gpu-grid-aggregation/gpu-grid-aggregator"));

var _binSorter = _interopRequireDefault(require("./utils/bin-sorter"));

var _scaleUtils = require("./utils/scale-utils");

var _colorUtils = require("./utils/color-utils");

var experimental = {
  BinSorter: _binSorter["default"],
  linearScale: _scaleUtils.linearScale,
  getLinearScale: _scaleUtils.getLinearScale,
  quantizeScale: _scaleUtils.quantizeScale,
  getQuantizeScale: _scaleUtils.getQuantizeScale,
  getQuantileScale: _scaleUtils.getQuantileScale,
  getOrdinalScale: _scaleUtils.getOrdinalScale,
  defaultColorRange: _colorUtils.defaultColorRange
};
exports.experimental = experimental;
//# sourceMappingURL=index.js.map